#define ENABLE_ERROR_RETURN   // Enable Returning Errors to AMS
#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization
#define MIN_AMS 100           // Compile for AMS 1.00 or higher
#define SAVE_SCREEN           // Save/Restore LCD Contents

#define USE_TI89              // Compile for 89

/* #define USE_TI92PLUS          // Compile for TI-92 Plus
#define USE_V200              // Compile for V200
*/

#include <tigcclib.h>

/*
#include "red.h"
#include "blue.h"
#include "green.h"

*/

#include "red89.h"
#include "blue89.h"
#include "green89.h"

#define SENTINEL_VALUE 0x91
#define BYTES_PER_ROW 30
#define NUM_ROWS 128

void VRLE(unsigned char *comp, unsigned char *decomp, int size) {
	int i,j;
	int pos = 0;

	for(i = 0; i < size; i++) {
		//decompress a run
		if (comp[i] == SENTINEL_VALUE) {
			i++;
			for(j = 0; j < comp[i + 1]; j++) {
				decomp[pos] = comp[i];
				pos += BYTES_PER_ROW;
				if (pos > BYTES_PER_ROW * NUM_ROWS) {
					pos -= BYTES_PER_ROW * NUM_ROWS;
					pos++;}
				}
			i++;
		}
		else {
			decomp[pos] = comp[i];
			pos += BYTES_PER_ROW;
			if (pos > BYTES_PER_ROW * NUM_ROWS) {
				pos -= BYTES_PER_ROW * NUM_ROWS;
				pos++;	}
		}
	}
}

void _main(void) {
 clrscr();
// if (!GrayOn()) return;
 while (kbhit() == 0) {

  VRLE(red1, LCD_MEM, sizeof red1);
//  memcpy (GetPlane (LIGHT_PLANE), LCD_MEM, LCD_SIZE);

  VRLE(blue1, LCD_MEM, sizeof blue1);
//  memcpy (GetPlane (DARK_PLANE), LCD_MEM, LCD_SIZE);

  VRLE(green1, LCD_MEM, sizeof green1);
//  memcpy (GetPlane (LIGHT_PLANE), LCD_MEM, LCD_SIZE);

  VRLE(red2, LCD_MEM, sizeof red2);
//  memcpy (GetPlane (DARK_PLANE), LCD_MEM, LCD_SIZE);

  VRLE(blue2, LCD_MEM, sizeof blue2);
//  memcpy (GetPlane (LIGHT_PLANE), LCD_MEM, LCD_SIZE);

  VRLE(green2, LCD_MEM, sizeof green2);
//  memcpy (GetPlane (DARK_PLANE), LCD_MEM, LCD_SIZE);

 }
// GrayOff();
};
